# 任务说明

使用对比学习对`MNIST`数据集进行预训练和分类

# 要求

1. 使用`Keras`构建模型
2. 自定义`DataGenerater`生成`minibatch`的样本图片和标签进行训练
3. 自定义对比损失函数代码
4. 预训练结束后使用`TSNE`可视化处理
5. 预训练结束后训练`MLP`层进行分类并告知准确率（`accuracy`）

# 任务记录

## 2023/03/28

由于我个人比较熟悉`pytorch`框架，未接触过`Keras`框架，因此今天看了一整天的[Keras开发文档](https://keras.io/zh/)，自己也跟着开发文档写了一些小例子。

## 2023/03/29

今天去看了对比学习的理论知识，依照理论搭建了一个简单的预训练模型和一个简单`MLP`模型，其中的一些隐藏层定义语句其实和`pytorch`框架没有太多差别。让我卡住的挺长时间的是`Keras`的自定义数据读取函数，文档当中虽然有详细的说明，但是习惯了`pytorch`中`torchvision.transforms`读取数据的框架，一时半会没能转换过来思维。

## 2023/03/30

今天看了`TSNE`可视化的一些相关教程，因为之前使用`pytorch`的时候可视化基本都托管到了`tensorboard`上，`tensorboard`也有类似`TSNE`的功能，直接调用对应接口就可以实现，今天也是第一次使用`scikit-learn`里的`TSNE`库。

已完成任务：

- [x] 使用`Keras`构建预训练模型
- [x] 自定义`DataGenerater`函数生成`minibatch`的样本图片和标签
- [x] 自定义对比损失函数（使用了交叉熵损失值）
- [x] 预训练结束后使用`TSNE`可视化处理（生成的图像存放与`./file`文件夹中）
- [x] 预训练结束后训练`MLP`层进行分类并告知准确率

存在的问题：

1. `TSNE`生成可视化图像速度慢。
2. 由于个人对无监督学习接触的项目较少，目前的代码也仅是根据[[1]](https://blog.csdn.net/cziun/article/details/119118768)[[2]](https://zhuanlan.zhihu.com/p/104384194?utm_source=zhihu)这两篇文章学到的理论知识加上我在`pytorch`框架上的经验完成的，其中的很多理论我不是很明确，因此代码的结果我自己也不是很确定是对是错。

![TSNE](./file/TSNE%E5%8F%AF%E8%A7%86%E5%8C%96.png)